﻿function Blood() {
    this.blood = [];
    this.next = 0;
    var i = 0;
    for (i = 0; i < 50; ++i) {
        this.blood[i] = { x: 0, y: 0, vx: 0, vy: 0, size: 0 }
    }
}

Blood.prototype.update = function (elapsed) {
    var max = this.blood.length;
    var i;
    var m = elapsed / 1000;
    for (i = 0; i < max; ++i) {
        if (this.blood[i].size > 3) {
            this.blood[i].x += this.blood[i].vx * m;
            this.blood[i].y += this.blood[i].vy * m;
            this.blood[i].size -= (50 * m);
        }
    }
}

Blood.prototype.render = function (ctx, camera) {
    var max = this.blood.length;
    var i;
    var size;
    for (i = 0; i < max; ++i) {
        size = this.blood[i].size;
        if (size > 3) {
            ctx.save();
            ctx.translate(this.blood[i].x - camera.x, this.blood[i].y - camera.y);
            ctx.beginPath();
            ctx.arc(size / -2, size / -2, size, 0, 2 * Math.PI, false);
            ctx.fillStyle = '#a11';
            ctx.fill();
            ctx.restore();
        }
    }
}

Blood.prototype.add = function (x, y) {
    var i = 0;
    for (i = 0; i < 12; ++i) {
        this.blood[this.next].x = x;
        this.blood[this.next].y = y;
        this.blood[this.next].vx = (Math.random() * 800) - 400;
        this.blood[this.next].vy = (Math.random() * 800) - 400;
        this.blood[this.next].size = 15;
        ++this.next;
        this.next %= this.blood.length;
    }
}