﻿function CameraControl() {
    this.x = 0;
    this.y = 0;

    this.w = 1920;
    this.h = 1080;

    this.resize = function (w, h) {
        this.w = w;
        this.h = h;
        this.halfw = Math.floor(this.w / 2);
        this.halfh = Math.floor(this.h / 2);
    }

    this.centerOn = function (x, y) {
        this.x = x - Math.floor(this.w / 2);
        this.y = y - Math.floor(this.h / 2);
    }

    this.ensureVisible = function (x, y) {
        var centerX = this.x + Math.floor(this.w / 2);
        var centerY = this.y + Math.floor(this.h / 2);

        var maxDiff = 150;

        var diffX = x - centerX;
        if (diffX > maxDiff) {
            this.x += diffX - maxDiff;
        }

        if (diffX < -maxDiff) {
            this.x -= -diffX - maxDiff;
        }

        var diffY = y - centerY;
        if (diffY > maxDiff) {
            this.y += diffY - maxDiff;
        }

        if (diffY < -maxDiff) {
            this.y -= -diffY - maxDiff;
        }
    }
}