﻿function Controller (canvas) {

    this.LEFT_BUTTON = 1;
    this.MIDDLE_BUTTON = 2;
    this.RIGHT_BUTTON = 4;

    this.buttons = 0;

    this.canvas = canvas;
    this.mousePos = { x: 0, y: 0 };

    this.status = "no status";

    var that = this;
    //this.canvas.addEventListener('mousemove', function(evt) { that.mouseMove(evt); }, false);

    /*
    this.canvas.addEventListener('mousedown', function (evt) { that.mouseDown(evt); }, false);
    this.canvas.addEventListener('mouseup', function (evt) { that.mouseUp(evt); }, false);
    this.canvas.addEventListener('contextmenu', function (evt) { evt.preventDefault(); return false; });

    this.canvas.addEventListener('touchstart', function (evt) { that.mouseDown(evt); return false; evt.preventDefault(); }, false);
    this.canvas.addEventListener('touchend', function (evt) { that.mouseUp(evt); return false; evt.preventDefault(); }, false);
    this.canvas.addEventListener('touchmove', function (evt) { evt.preventDefault(); }, false);
    */

    // Scratch card code
    this.canvas.addEventListener('mousemove',function (evt) { evt.preventDefault(); return false; }, false);

    this.canvas.addEventListener('touchstart', function (evt) { that.mouseDown(evt); }, false); //evt.preventDefault(); return false; });
    this.canvas.addEventListener('touchend', function (evt) { that.mouseUp(evt); }, false);
    this.canvas.addEventListener('touchmove', function (evt) { evt.preventDefault(); return false; }, false);

    this.canvas.addEventListener('mousedown', function (evt) {  that.mouseDown(evt); }, false);
    this.canvas.addEventListener('mouseup', function (evt) { that.mouseUp(evt); }, false);
    this.canvas.addEventListener('contextmenu', function (evt) { evt.preventDefault(); return false; }, false);


    this.clearButtons = function() {
        this.buttons = 0;
    }

    this.leftButton = function() {
        return this.LEFT_BUTTON === (this.buttons & this.LEFT_BUTTON);
    }

    this.rightButton = function() {
        return this.RIGHT_BUTTON === (this.buttons & this.RIGHT_BUTTON);
    }

    this.mouseMove = function (evt) {
        this.mousePos = this.calculateMousePos(evt);
        evt.preventDefault();
        return false;
    }

    this.mouseDown = function(evt) {
        this.mousePos = this.calculateMousePos(evt);

        switch (evt.button) {
            case 0: this.buttons |= this.LEFT_BUTTON; break;
            case 1: this.buttons |= this.MIDDLE_BUTTON; break;
            case 2: this.buttons |= this.RIGHT_BUTTON; break;
        }

        if (evt.touches && evt.touches.length > 0) {
            this.buttons |= this.LEFT_BUTTON;
        }
        evt.preventDefault();
        return false;
    }

    this.mouseUp = function (evt) {
        evt.preventDefault();
        return false;
    }

    this.touchDown = function (evt) {
        var pos = this.calculateMousePos(evt);
        this.status = "X: " + pos.x + " Y: " + pos.y;
        return;
    }

    this.calculateMousePos = function (evt) {
        var rect = this.canvas.getBoundingClientRect();
        //var root = document.documentElement;

        var mouseX = 0;
        var mouseY = 0;
        if (evt.clientX) { mouseX = evt.clientX - rect.left; }// - root.scrollLeft;
        if (evt.clientY) { mouseY = evt.clientY - rect.top; }// - root.scrollTop;

        if (evt.touches && evt.touches.length > 0) {
            mouseX = evt.touches[0].clientX - rect.left;// - root.scrollLeft;
            mouseY = evt.touches[0].clientY - rect.top;// - root.scrollTop;
        }

        return {
            x: mouseX,
            y: mouseY
        }
    }
}