﻿function Sequences() {
    this.sequences = [];
    this.currentSequence = '';
    this.currentFrame = 0;
    this.nextFrameTime = 0;
}

Sequences.prototype.add = function (key, animation) {
    this.sequences[key] = animation;
}

Sequences.prototype.setCurrent = function (key, frame) {
    this.currentSequence = key;
    this.currentFrame = frame || 0;
}

Sequences.prototype.update = function (now) {
    if (now >= this.nextFrameTime) {
        this.advance();
    }
}
Sequences.prototype.getCurrent = function () {
    if (this.sequences[this.currentSequence]) {
        var sequence;
        var currentSequence;
        var currentFrame;
        var frame;
        currentSequence = this.currentSequence;
        currentFrame = this.currentFrame;
        sequence = this.sequences[currentSequence];
        frame = sequence.frames[currentFrame];
        return frame.asset;
    }
    return "invalid";
}

Sequences.prototype.advance = function () {
    if (!this.sequences || !this.currentSequence) {
        return;
    }

    var sequence;
    sequence = this.sequences[this.currentSequence];
    ++this.currentFrame;
    if (sequence.loop) {
        this.currentFrame %= sequence.frames.length;
    } else {
        if (this.currentFrame >= sequence.frames.length) {
            --this.currentFrame;
        }
    }
    this.nextFrameTime = (new Date()).getTime() + sequence.frames[this.currentFrame].delay;
    return;
}
