﻿function Player(controller, assets, x, y, w, h) {
    Sprite.call(this, assets, x, y, w, h);
    this.controller = controller;

    this.animations.add('idle', { loop: true, frames: [
            { asset: "birdr1", delay: 250 },
    ]});

    this.animations.add('flyright', { loop: true, frames: [
                { asset: "birdr1", delay: 100 },
                { asset: "birdr2", delay: 100 },
                { asset: "birdr3", delay: 100 },
                { asset: "birdr4", delay: 100 },
    ]});

    this.animations.add('flyleft', { loop: true, frames: [
                    { asset: "birdl1", delay: 100 },
                    { asset: "birdl2", delay: 100 },
                    { asset: "birdl3", delay: 100 },
                    { asset: "birdl4", delay: 100 },
        ]
    });

    this.animations.setCurrent('flyright');
}
Player.prototype = inherit(Sprite.prototype);
Player.prototype.constructor = Player;

Player.prototype.update = function (elapsed, map) {
    var flapped = false;
    if (this.controller.leftButton()) {
        this.accelerationX -= 75;
        flapped = true;
        this.animations.setCurrent("flyleft");
    }

    if (this.controller.rightButton()) {
        this.accelerationX += 75;
        flapped = true;
        this.animations.setCurrent("flyright");
    }

    if (flapped) {
        this.accelerationY -= 200;
    }
    Sprite.prototype.update.call(this, elapsed, map);
}
