﻿function Shrinker(x, y, w, h, style) {
    Entity.call(this, x, y, w, h);

    style = style || "yellow";

    this.pivotX = 0;
    this.pivotY = 0;
    this.originX = x;
    this.originY = y;
    this.limitX = 100;
    this.limitY = 0;

    this.gravity = 0;
    this.vx = 200;
    this.vy = 0;
    this.fill = "#ffff00";

    if (style == "green") { // Stomper
        this.vx = 0;
        this.vy = 200;
        this.width = 32;
        this.height = 64;
        this.limitX = 0;
        this.limitY = 96;
        this.fill = "#00ff00";
    }

    if (style == "blue") {  // Dancer
        this.vx = 100;
        this.vy = 200;
        this.width = 32;
        this.height = 64;
        this.limitX = 96;
        this.limitY = 96;
        this.fill = "#0000ff";
    }

}
Shrinker.prototype = inherit(Entity.prototype);
Shrinker.prototype.constructor = Shrinker;

Shrinker.prototype.render = function (ctx) {
   ctx.beginPath();
   ctx.rect(0, 0, this.width, this.height);
//   ctx.rect(this.width / -2, this.height / -2, this.width, this.height);
   ctx.fillStyle = this.fill;
   ctx.fill();
   ctx.lineWidth = 2;
   ctx.strokeStyle = 'black';
   ctx.stroke();
}

Shrinker.prototype.testCollision = function (p) {
    // Horizontal
    if ((p.x >= this.x && p.x < this.x + this.width) ||
        (this.x >= p.x && this.x < p.x + p.width)) {
        // Vertical
        if ((p.y >= this.y && p.y < this.xy + this.height) ||
            (this.y >= p.y && this.y < p.y + p.height)) {
            return true;
        }
    }
    return false;
}

Shrinker.prototype.update = function (elapsed, map) {
    var m = elapsed / 1000;
    this.x += this.vx * m
    if (Math.abs(this.x - this.originX) > this.limitX) {
        this.vx = -this.vx;
        this.x += this.vx * m
    }

    this.y += this.vy * m;
    if (Math.abs(this.y - this.originY) > this.limitY) {
        this.vy = -this.vy;
        this.y += this.vy * m;
    }
    return;
}